<template>
    <div class="products">
       <div class="row">
          <div class="col-6 col-lg-3 col-sm-6 col-md-4" 
          v-for="(item, index) in limitedProducts" 
          :key="index">
             <card-template :item="item" />
          </div>
       </div>

       <nav class="navigation pagination" v-if="noPages.length > 1">
         <div class="nav-links">
           <a :class="{disabled: (currentPage === 0)}" @click="previous" class="prev page-numbers">Previous</a>
           <a v-for="(page, ind) in noPages" class="page-numbers" :class="{current: page === currentPage}" @click='(e) => {goToPage(page, e)}'><span class="meta-nav screen-reader-text"></span>{{page + 1}}</a>
           <a :class="{disabled: (currentPage + 1 === noPages.length)}" class="next page-numbers" @click="next">Next</a>
         </div>
       </nav>
    </div>
</template>


<script>
import axios from "axios";
import CardTemplate from "../shared/CardTemplate";
export default {
  name: 'productslist',
  props: {
    products_list: Array,
    filters: Object
  },
  components: { CardTemplate},
  methods: {
    previous: function (e) {
      e.preventDefault()
      if (this.currentPage !== 0) {
        --this.currentPage
      }
    },
    next: function (e) { 
      e.preventDefault()
      if (this.currentPage + 1 !== this.noPages.length) {
        ++this.currentPage
      }
    },
    goToPage: function (page, e) {
      e.preventDefault();
      this.currentPage = page;
    },
    firstPage: function(e) {
      e.preventDefault();
      this.currentPage = 0;
    }
  },
  data() {
    return {
      selectedProduct: Object,
      currentPage: 0
    };
  },
  watch: {
    'filters': {
      deep: true,
      handler: function(nVal) {
        this.currentPage = 0;
      } 
    }
  },
  computed: {
    noPages: function () { // No. pages as an array. Used for rendering paginator
      if (!this.filteredData) return [];
      let pages = Math.ceil(this.filteredData.length / 12);
      pages = [...Array(pages).keys()];
      pages = pages.filter(num => {
        return num < this.currentPage + 12 && num > this.currentPage - 12;
      }); 

      return pages;
    },
    limitedProducts: function() {
      if (!this.filteredData) return [];
      let limitedData = this.filteredData.slice(
        this.currentPage * 12,
        12 * (this.currentPage + 1)
      );
      return limitedData;
    },
    filteredData: function () {
      if (!this.products_list) return [];
      let filteredProducts = JSON.parse(JSON.stringify(this.products_list));

      if (this.filters.category.length >= 1) {
        filteredProducts = filteredProducts.filter(pr => this.filters.category.includes(pr.productCategory));
      }

      if (this.filters.sort) {
        filteredProducts.sort((a, b) => {
          if (this.filters.sort === 'Сначала Новое') {
            return new Date(b.date) - new Date(a.date);
          } else if (this.filters.sort === 'Сначала Старое') {
            return new Date(a.date) - new Date(b.date);
          } else if (this.filters.sort === 'Цена по убыванию') {
            return b.items[0].price - a.items[0].price;
          } else if (this.filters.sort === 'Цена по возрастанию') {
            return a.items[0].price - b.items[0].price;
          }
        });
      }

      return filteredProducts;
    }
  }
};
</script>

<style>
.footerIcons {
  font-size: 95%;
}

</style>
